/* hires_timer.cpp */
#define TEST 0

#define INCL_DOS

 #define INCL_DOSPROFILE
 #include <os2.h>

#include <stdio.h>
#include <conio.h>
#include "hires_timer.h"
#include "iopl32.h"

void inPortTest_usTimerDelay(int Nraz, int nport);

double usTimerDelay_A, usTimerDelay_B;
int usTimerDelay_Port;

int init_usTimerDelay(int testPort )
{
  double t0,t1,t2,dt1,dt2;
  int Nraz0= 1000, Nraz1= 10, i,j;

  DosSetPriority( PRTYS_THREAD, PRTYC_REGULAR, +15L, 0UL );
  t0 = GetHiresTimer();

// p ६ 믮 _inp
   {
     t0 = GetHiresTimer();
      for(j=0;j<Nraz1;j++)
          inPortTest_usTimerDelay(Nraz0, testPort);
     t1 = GetHiresTimer();
      for(j=0;j<Nraz1;j++)
          inPortTest_usTimerDelay(Nraz0*2, testPort);
     t2 = GetHiresTimer();
     /* ६  us (ᥪ)*/
     dt1 = (t1 - t0) * 1000000.;
     dt2 = (t2 - t1) * 1000000.;
     usTimerDelay_B =  (double) (Nraz0 *Nraz1) / (dt2 -dt1);
   }

   usTimerDelay_Port = testPort;

/* p頥  p쭮 pp */
   DosSetPriority( PRTYS_THREAD, PRTYC_REGULAR, -15L, 0UL );

   return 0;
}

/*   p p 믮  inp  믮 p */
void inPortTest_usTimerDelay(int Nraz, int nport)
{   int i;
   enterIOPL32();
         for(i=0;i<Nraz;i++)
                _inp(nport);
   leaveIOPL32();
}
void inPortTest_usTimerDelayIOPL32(int Nraz, int nport)
{   int i;
         for(i=0;i<Nraz;i++)
                _inp(nport);
}

static ULONG  ulTmrFreq;  /*  Timer Frequency. */
static QWORD  qwTmrTime;  /*  Time. */
static double HiresTimercof = 1./1193167.;


int StartHiresTimer(void)
{
 APIRET    rc;          /*  Return Code. */
 double T,T1;
 rc = DosTmrQueryFreq(&ulTmrFreq);
 HiresTimercof = 1./ (double)ulTmrFreq;
 return 0;
}

double GetHiresTimer(void)
{ double T;
/* Provides a snapshot of the time from the IRQ0 high resolution timer (Intel 8254). */
  DosTmrQueryTime(&qwTmrTime);
  T  = (qwTmrTime.ulLo + qwTmrTime.ulHi*4294967295.) * HiresTimercof;
  return T;
}

void udelay(unsigned long usecs)
{
static int Nraz=0, old_usecs= -1;
   if(old_usecs != usecs)
   {
       Nraz = (int)(usecs * usTimerDelay_B);
       old_usecs = usecs;
   }
   inPortTest_usTimerDelay(Nraz, usTimerDelay_Port);
}

void udelayIOPL32(unsigned long usecs)
{
static int Nraz=0, old_usecs= -1;
   if(old_usecs != usecs)
   {
       Nraz = (int)(usecs * usTimerDelay_B);
       old_usecs = usecs;
   }
   inPortTest_usTimerDelayIOPL32(Nraz, usTimerDelay_Port);
}

int main1(int n, char *par[]);
#if TEST

int main(int n, char *par[])
{
   int testPort  = 0x200, i;
 int raz = 0;

   double t1,t2, dt[10];

 //  testPort  = 0xb850;
   testPort  = 0x300;

    StartHiresTimer();

   init_usTimerDelay(testPort );
   printf("TestPort:\nA=%f,B=%f\n",usTimerDelay_A, usTimerDelay_B);
for(raz = 0; raz < 100; raz++)
{
   t1 = GetHiresTimer();
      for(i=0;i<1000;i++)
                    udelay(10);
   t2 = GetHiresTimer();
    dt[0] = (t2-t1)*1000000/1000;

   t1 = GetHiresTimer();
      for(i=0;i<1000;i++)
                  udelay(20);
   t2 = GetHiresTimer();
   dt[1] = (t2-t1)*1000000/1000;

   t1 = GetHiresTimer();
      for(i=0;i<1000;i++)
      {     udelay(10);
            udelay(10);
      }
   t2 = GetHiresTimer();
  dt[2] = (t2-t1)*1000000/1000;

   t1 = GetHiresTimer();
      for(i=0;i<1000;i++)
                     udelay(1000);
   t2 = GetHiresTimer();
   dt[3] = (t2-t1)*1000000/1000;
DosSleep(64);
   printf("10 dt=%f   ",  dt[0]);
   printf("10-2 dt=%f ",  dt[1]);
   printf("10x2 dt=%f  ", dt[2]);
   printf("1000 dt=%f\n", dt[3]);
DosSleep(320);
}
   t1 = GetHiresTimer();
for(i=0;i<1000;i++)
  DosTmrQueryTime(&qwTmrTime);
   t2 = GetHiresTimer();
  dt[5] = (t2-t1)*1000000;
   printf("1000  DosTmrQueryTime dt=%f   ",  dt[5]);

//   main1(n, par);

}

#endif
