/* l780.h */
/* L-780 registers and commands */

#ifndef __L780_H
#define __L780_H

#include "plx9050.h"

/* PCI Subsystem ID */

#define SUB_ID_L761 0x4C373631
#define SUB_ID_L780 0x4C373830
#define SUB_ID_L783 0x4C373833

/* EEPROM control bits */

#define L780_EESK CNTRL_EEWD  /* EEPROM Serial Data Clock */
#define L780_EEWD CNTRL_EESK  /* EEPROM Write Data */
#define L780_EERD CNTRL_EERD  /* EEPROM Read Data */
#define L780_EECS CNTRL_USER0  /* EEPROM Chip Select */

/* L780 Local Address Space */

#define IDMA_DATA 0x00
#define IDMA_ADDR 0x02
#define DSP_INTR 0x04
#define DSP_RESET 0x06

#define IDMA_EXTENT 0x08

#endif
