/* l780os2.h */

#include "l7_port.h"
#include "pci.h"
#include "lbios.h"
#include "l780.h"
/*  PCI specific structures */
#pragma pack( 1 )

typedef struct
{
   BYTE byReturnCode;
   BYTE byHWMechanism;
   BYTE byMajorRevision;
   BYTE byMinimumRevision;
   BYTE byLastBus;
} PCI_INFO, *PPCI_INFO;


// Not implemented yet as I don't need to write at the moment
typedef struct
{
   BYTE bySubFunction;
   BYTE byBusNumber;
   BYTE byDevFuncNumber;
   BYTE byConfigRegister;
   BYTE bySize;
   ULONG ulData;
} PCI_CONFIG_WRITE_CMD, **PPCI_CONFIG_WRITE_CMD;


typedef struct
{
   BYTE bySubFunction;
   BYTE byBusNumber;
   BYTE byDevFuncNumber;
   BYTE byConfigRegister;
   BYTE bySize;
} PCI_CONFIG_READ_CMD, **PPCI_CONFIG_READ_CMD;


typedef struct
{
   BYTE byReturnCode;
   ULONG ulPCIData;
} PCI_CONFIG_READ_DATA, **PPCI_CONFIG_READ_DATA;


typedef struct
{
   BYTE byPCIBusNumber;
   BYTE byPCIDeviceNumber;
   BYTE byPCIFunctionNumber;
   BYTE byPCIRegisterNumber;
   BYTE byPCIReadorWrite;
   BYTE byDataType;
} PCI_REQUEST, *PPCI_REQUEST;

/***********************************/
/* Find PCi Device - Subfunction 1 */
typedef struct
{
   BYTE  bySubFunction;
   USHORT  uDeviceId;
   USHORT  uVendorId;
   BYTE  byIndex;
} PCI_FIND, *PPCI_FIND;

typedef struct
{
   BYTE  byReturnCode;
   BYTE  byPCIBusNumber;
   BYTE  byPCIFunctionNumber;
} PCI_FIND_DATA, *PPCI_FIND_DATA;
/***********************************/

typedef struct _fifo_buf
{
 unsigned char *data;
 int maxsize;
 int size;
 int head;
 int tail;
 int count;
 int fragsize;
} fifo_buf;

typedef struct _BOARD_STRUCT
{
 int number;  /* Number of board */
 int unit;  /* Slot number */
 void *next;
 struct pci_dev *dev;  /* PCI device */
 int id;
 int ioplx;  /* PLX control registers */
 int base;  /* I/O base address */
 void *array;  /* Mapped IDMA array */
 int var;  /* Data area offset in DSP DM */
 int bios;  /* BIOS loaded and tested */
 int trigger;  /* Triggers */
 int format;
 int adc_bits;  /* ADC bits */
 int adc_max;  /* Max ADC rate */
 int channels;  /* Number of active channels */
 int rate;
 int max_fifo_adc;
 int max_fifo_dac;
 int opened;
// struct semaphore sem_open;
// wait_queue_head_t wait_open;
// wait_queue_head_t wait_in;
// wait_queue_head_t wait_out;
 int FifoIn; /* Current ADC fragment */
 fifo_buf InBuf;
 int FifoOut; /* Current DAC fragment */
 fifo_buf OutBuf;
 BOARD_DESCR descr;  /* Board description from EEPROM */
} BOARD_STRUCT;

int ttl_out(int dev, int Value);
int ttl_in(int dev);
int pflagCSC_out(int dev, int Value);
int pflag_out(int dev, int Value);
int pflag_in(int dev);
int pflagCSC_in(int dev);
int getADC(int dev,int Channel);

#pragma pack( )


