/* lbios.h */
/* LBIOS structures, variables, commands & other stuff */

#ifndef __LBIOS_H
#define __LBIOS_H

//#include <linux/ioctl.h>
//#include <linux/soundcard.h>
//#include <asm/types.h>

#define ID_L761 0x4C373631
#define ID_L780 0x4C373830
#define ID_L783 0x4C373833

#define ADDR_DM 0x4000


// , ᮤঠ ଠ  ,  ࠭  . 
typedef struct _BOARD_DESCR
{
 char serial[9];               // ਩ 
 char name[5];                 //  
 char revision;                        // ॢ 
 char dsp_type[5];             // ⨯ ⠭ DSP
 long freq;                    //    
 unsigned short is_dac;                // 䫠  
 unsigned short _res[7];       // १ࢨ஢
} BOARD_DESCR;

/* LBIOS variables */

#define L_CONTROL_TABLE    0x0A00

#define L_SCALE            0x0D00
#define L_ZERO             0x0D04
#define L_CONTROL_HEIGHT   0x0D08

#define L_READY            0x0D40
#define L_TMODE1           0x0D41
#define L_TMODE2           0x0D42

#define L_DSP_TYPE         0x0D48
#define L_COMMAND          0x0D49
#define L_FIRST_SAMPLE     0x0D4A
#define L_TTL_OUT          0x0D4C
#define L_TTL_IN           0x0D4D
#define L_DAC_FIFO_PTR     0x0D4F
#define L_ADC_FIFO_PTR     0x0D50
#define L_TEST_LOAD        0x0D52
#define L_ADC_RATE         0x0D53
#define L_ADC_INTERFRAME   0x0D54
#define L_DAC_RATE         0x0D55
#define L_DAC_VALUE        0x0D56
#define L_ENABLE_IRQ       0x0D57
#define L_IRQ_STEP         0x0D58
#define L_IRQ_FIFO_ADDRESS 0x0D5A
#define L_ENABLE_IRQ_VALUE 0x0D5B
#define L_ADC_SAMPLE       0x0D5C
#define L_ADC_CHANNEL      0x0D5D
#define L_DAC_SCLK_DIV     0x0D5E
#define L_CORRECTION_ENABLE    0x0D60
#define L_ADC_ENABLE       0x0D62
#define L_ADC_FIFO_BASE    0x0D63
#define L_ADC_FIFO_BASE_INDEX  0x0D64
#define L_ADC_FIFO_LENGTH  0x0D65
#define L_ADC_NEW_FIFO_LENGTH  0x0D66
#define L_DAC_ENABLE       0x0D67
#define L_DAC_FIFO_BASE    0x0D68
#define L_DAC_FIFO_LENGTH  0x0D69
#define L_DAC_NEW_FIFO_LENGTH  0x0D6A
#define L_SYNC_TYPE        0x0D70
#define L_SYNC_CHANNEL     0x0D73
#define L_SYNC_LEVEL       0x0D74
#define L_SYNC_MODE        0x0D75
#define L_SYNC_EDGE        0x0D76

#define L_SET_PFCSC        0x0D80
#define L_SET_PFD          0x0D81

/* LBIOS commands */

#define C_TEST                 0x0000
#define C_LOAD_CONTROL_TABLE   0x0001
#define C_ENABLE_ADC           0x0002
#define C_ADC_FIFO_CFG         0x0003
#define C_SET_ADC_FRAME        0x0004
#define C_ENABLE_DAC           0x0005
#define C_DAC_FIFO_CFG         0x0006
#define C_SET_DAC_RATE         0x0007
#define C_ADC_SAMPLE           0x0008
#define C_TTL_IN               0x0009
#define C_TTL_OUT              0x000A
#define C_SYNC_CONFIG          0x000B
#define C_ENABLE_IRQ           0x000C
#define C_IRQ_TEST             0x000D
#define C_SET_DSP_TYPE         0x000E

#define C_SET_PF               0x000F

#endif
