/* pci_utils.cpp */
#define POKA 0

#define INCL_DOS
#define INCL_DOSERRORS

#include <os2.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <errno.h>
#include <conio.h>
#include "l780os2.h"
#include "xdsp.h"
#include "iopl32.h"
#include "hires_timer.h"

/*७ 㭪樨  */

HFILE tpci_OpenOEMDriver( void );
extern "C" void CloseAccess_to_PCI(void);
BOOL tpci_ReadGeneralInfo( HFILE hfOEMDriver );

/* ७  ६ */
APIRET ApiPCI_RC;
HFILE hfPCI = NULL;
PCI_INFO PciInfo;

struct pci_dev PCIdev0;

static int Boards = 0;  /* Number of boards found */
static BOARD_STRUCT *FirstBoard = NULL;
static BOARD_STRUCT LCardBoard[2];

/* ७ ⠭ */
int VendorId = PCI_VENDOR_ID_PLX;
int DeviceId = PCI_DEVICE_ID_PLX_9050;

static int flash_delay = 10;  /* us */

static char *dsp_name[] = {"2184", "2185", "2186", NULL};
static int d_max_adc[] = {0x800, 0x3800, 0x1800, 0};
static int d_max_dac[] = {0x400, 0x1000, 0x800, 0};
static int d_adc_index[] = {2, 0, 1, 0};

static int sub_id[] =    {SUB_ID_L761, SUB_ID_L780, SUB_ID_L783, 0};
char *PLX_Board_Names[]= {"L761", "L780","L783", "Unknown"};
static int t_id[] = {0x761, 0x780, 0x783, 0};
static int t_adc_bits[] = {14, 14, 12, 0};
static int t_adc_max[] = {125000, 400000, 1000000, 0};

static copr_buffer cbuf;

/*******************************************************************/

int InitAccess_to_PCI(void)
{
      // Open the OEM Helper driver
      hfPCI = tpci_OpenOEMDriver( );

      if(!hfPCI)
      {
         printf( "\n\nSorry, I had an error while opening your OEMHLP$ driver (0x%08X)\r\n", ApiPCI_RC );
         return 0;
      }

      tpci_ReadGeneralInfo( hfPCI );

      return 1;
}


HFILE tpci_OpenOEMDriver( void )
{  ULONG ulAction;
   HFILE hfOEMDriver;


   ApiPCI_RC = DosOpen( "OEMHLP$",   // OEM driver
                   &hfOEMDriver, // file handle
                   &ulAction,    // action taken
                   0L,           // params
                   0,
                   1,
                   0x40,
                   0L );

   if ( ApiPCI_RC == NO_ERROR )
      return hfOEMDriver;
   else
      return ( HFILE )NULL;

} // endof tpci_OpenOEMDriver


extern "C" void CloseAccess_to_PCI(void)
{   // Driver is still open so close it
    if(hfPCI)
       ApiPCI_RC = DosClose( hfPCI );
    hfPCI = NULL;
}

BOOL tpci_ReadGeneralInfo( HFILE hfOEMDriver )

{
   ULONG ulParm = 0, ulData;
   UCHAR ucInfo = 0;

   ulData = sizeof( PciInfo );
   memset( &PciInfo, 0, sizeof( PciInfo ) );

   ApiPCI_RC = DosDevIOCtl( hfOEMDriver,
                       0x80,
                       0x0B,
                       &ucInfo,
                       1,
                       &ulParm,
                       &PciInfo,
                       ulData,
                       &ulData );
   if ( ApiPCI_RC )
   {
      printf( "\nPCI info call failed (%d=0x%08X) %d,%d\r",
                           ApiPCI_RC, ApiPCI_RC, ulParm, ulData );
      return FALSE;
   } // endif
   else
   {
      printf( //"\nOpened driver o.k. (%02X)\r\n\n"
             "\n\nGeneral PCI System Info:\r\n"
             "    Hardware Mechanism: %02X\r\n"
             "    PCI Revision: %02X.%02X\r\n"
             "    Last PCI BUS has Number: %02X\r\n",
             //PciInfo.byReturnCode,
             PciInfo.byHWMechanism,
             PciInfo.byMajorRevision,
             PciInfo.byMinimumRevision,
             PciInfo.byLastBus );
      return TRUE;
   } // endelse got pci info o.k.

} // endof tpci_ReadGeneralInfo


int tpci_ReadPCIdata( HFILE hfOEMDriver,
                      int bus, int deviceNumber, int function, int RegisterNumber, int datatype,
                      int *ierr)
{

   PCI_CONFIG_READ_CMD  PciConfReadCmd;
   PCI_CONFIG_READ_DATA PciConfReadData;
   ULONG ulParm = 0, ulData;

   *ierr = 0;
   ulData = sizeof( PciConfReadData );
   ulParm = sizeof( PciConfReadCmd );
   memset( &PciConfReadCmd,  0, sizeof( PciConfReadCmd  ) );
   memset( &PciConfReadData, 0, sizeof( PciConfReadData ) );

   PciConfReadCmd.bySubFunction = 0x03; //Read PCI Configuration Space
   PciConfReadCmd.byBusNumber   = bus;  // PCI BusNumber;
   PciConfReadCmd.byDevFuncNumber =
             (deviceNumber<<3) | (function&0x7) ; // Combined device/function byte -  5+3bits
   PciConfReadCmd.byConfigRegister = RegisterNumber; // PCI Device Register to access;
   PciConfReadCmd.bySize =  datatype; //04 = DWORD, 02 = WORD, 01 = BYTE

   ApiPCI_RC = DosDevIOCtl( hfOEMDriver,
                       0x80,
                       0x0B,
                       &PciConfReadCmd,
                       sizeof( PciConfReadCmd ),
                       &ulParm,
                       &PciConfReadData,
                       sizeof( PciConfReadData ),
                       &ulData );
   if ( ApiPCI_RC )
   {
//      printf( "\nPCI Read call failed (%d=0x%08X) %d,%d\r", ApiRC, ApiRC, ulParm, ulData );
      *ierr = 1;
      return ApiPCI_RC;
   } // endif
   else
   {
//      printf( "\n\nRead PCI Configuration Data: %lx", PciConfigurationReadData.ulPCIData );
      *ierr = 0;
   } // endelse got pci info o.k.

   return PciConfReadData.ulPCIData;

} // endof tpci_ReadPCIdata

/*  4   ⠭ dev_funct (5+3) */
int tpci_ReadPCIdata( HFILE hfOEMDriver, int bus, int dev_funct, int RegisterNumber, int *ierr)
{

   PCI_CONFIG_READ_CMD  PciConfReadCmd;
   PCI_CONFIG_READ_DATA PciConfReadData;
   ULONG ulParm = 0, ulData;

   *ierr = 0;
   ulData = sizeof( PciConfReadData );
   ulParm = sizeof( PciConfReadCmd );
   memset( &PciConfReadCmd,  0, sizeof( PciConfReadCmd  ) );

   PciConfReadCmd.bySubFunction = 0x03; //Read PCI Configuration Space
   PciConfReadCmd.byBusNumber   = bus;  // PCI BusNumber;
   PciConfReadCmd.byDevFuncNumber = dev_funct; // Combined device/function byte -  5+3bits
   PciConfReadCmd.byConfigRegister = RegisterNumber; // PCI Device Register to access;
   PciConfReadCmd.bySize =  4; //04 = DWORD, 02 = WORD, 01 = BYTE

   ApiPCI_RC = DosDevIOCtl( hfOEMDriver,
                       0x80,
                       0x0B,
                       &PciConfReadCmd,
                       sizeof( PciConfReadCmd ),
                       &ulParm,
                       &PciConfReadData,
                       sizeof( PciConfReadData ),
                       &ulData );
   if ( ApiPCI_RC )
   {  *ierr = 1;
      return ApiPCI_RC;
   } else {
      *ierr = 0;
   } // endelse got pci info o.k.

   return PciConfReadData.ulPCIData;

} // endof tpci_ReadPCIdata

int tpci_FindDevicePCI( HFILE hfOEMDriver, unsigned int vendor, unsigned int device, unsigned int index,
                        PCI_FIND_DATA *find)
{
   PCI_FIND      PciFindCmd;
   ULONG ulParm, ulData;

   memset( &PciFindCmd, 0, sizeof( PciFindCmd ) );
   ulParm = sizeof( PciFindCmd );
   ulData = sizeof( PCI_FIND_DATA );

   PciFindCmd.bySubFunction = 0x01; //Find PCi Device
   PciFindCmd.uDeviceId     = device;
   PciFindCmd.uVendorId     = vendor;
   PciFindCmd.byIndex       = index;

   ApiPCI_RC = DosDevIOCtl(  hfOEMDriver,
                       0x80,
                       0x0B,
                       &PciFindCmd,
                       sizeof( PciFindCmd ),
                       &ulParm,
                       find,
                       sizeof( PCI_FIND_DATA ),
                       &ulData );
  if(ApiPCI_RC)
  {
      return 0;
  }

//  printf( "\nPCI_find_device return: %x %x %x\n",
//             find->byReturnCode,
//             find->byPCIBusNumber,
//             find->byPCIFunctionNumber);

  return 1;
} // endof tpci_FindDevicePCI

int tpci_WritePCIdata( HFILE hfOEMDriver,
                      int bus, int deviceNumber, int function, int RegisterNumber, int datatype,
                      int *ierr, int data)
{

   PCI_CONFIG_WRITE_CMD PciConfigurationWriteCmd;
   PCI_CONFIG_READ_CMD  PciConfigurationReadCmd;
   PCI_CONFIG_READ_DATA PciConfigurationReadData;
   BYTE byTempByte1, byTempByte2, byTempByte3;
   ULONG ulParm = 0, ulData;

   *ierr = 0;
   ulData = sizeof( PciConfigurationReadData );

   memset( &PciConfigurationWriteCmd, 0, sizeof( PciConfigurationWriteCmd ) );
   memset( &PciConfigurationReadCmd,  0, sizeof( PciConfigurationReadCmd  ) );
   memset( &PciConfigurationReadData, 0, sizeof( PciConfigurationReadData ) );

   // Device/function number - upper 5 bits of byte = device #, lower 3 bits is function #
   // Make the device/function number byte out of seperate two bytes
   byTempByte1 = deviceNumber << 3;
   byTempByte2 = byTempByte1 | 0x07;
   byTempByte3 = function | 0xf8;
   PciConfigurationReadCmd.byDevFuncNumber = byTempByte2 & byTempByte3; // Combined device/function byte
   // Read PCI configuration data space @ address supplied in byPCIReadRegister
   // Registers 0 -> max. 256 can be selected
   PciConfigurationReadCmd.bySubFunction = 0x04; // PCIRequest.byPCIReadorWrite+2; /// Index added to map to OEM subfunction
   // Location of PCI device
   PciConfigurationReadCmd.byBusNumber = bus; // PCI BusNumber;
   // PCI configuration register to read
   PciConfigurationReadCmd.byConfigRegister = RegisterNumber; // PCI Device Register to access;
   // Size of data returned from this register; 04 = DWORD, 02 = WORD, 01 = BYTE
//??????
   if(RegisterNumber%4 == 1) datatype = 1;
   else if(RegisterNumber%4 == 3) datatype = 1;
   else if(RegisterNumber%4 == 2) datatype = 2;
   else if(RegisterNumber%4 == 0) datatype = 4;

//?????
   PciConfigurationReadCmd.bySize =  datatype;

   ApiPCI_RC = DosDevIOCtl( hfOEMDriver,
                       0x80,
                       0x0B,
                       &PciConfigurationReadCmd,
                       sizeof( PciConfigurationReadCmd ),
                       &ulParm,
                       &PciConfigurationReadData,
                       sizeof( PciConfigurationReadData ),
                       &ulData );
   if ( ApiPCI_RC )
   {
//      printf( "\nPCI Read call failed (%d=0x%08X) %d,%d\r", ApiRC, ApiRC, ulParm, ulData );
      *ierr = 1;
      return ApiPCI_RC;
   } // endif
   else
   {
//      printf( "\n\nRead PCI Configuration Data: %lx", PciConfigurationReadData.ulPCIData );
      *ierr = 0;
   } // endelse got pci info o.k.

   return PciConfigurationReadData.ulPCIData;

} // endof tpci_AccessConfAddressReg

/*******************************************************/
int pci_present(void)
{
   return  InitAccess_to_PCI();
}


struct pci_dev *pci_find_device (unsigned int vendor, unsigned int device, struct pci_dev *from)
{
   PCI_FIND_DATA pciFindData;
   int rc, ierr, ind,i;
   ind = from->index;
   rc = tpci_FindDevicePCI(hfPCI, vendor, device, ind, &pciFindData);
   if(rc == 0)
           return NULL;

  printf( "\nPCI_find_device return: %x %x %x\n",
             pciFindData.byReturnCode,
             pciFindData.byPCIBusNumber,
             pciFindData.byPCIFunctionNumber);

  from->busNumber = pciFindData.byPCIBusNumber;
  from->devfn     = pciFindData.byPCIFunctionNumber;
  from->vendor    = (unsigned short) vendor;
  from->device    = (unsigned short) device;

//  ind = tpci_ReadPCIdata(hfPCI, pciFindData.byPCIBusNumber,
//                        (pciFindData.byPCIFunctionNumber>>3),(pciFindData.byPCIFunctionNumber& 0x7),
//                        PCI_SUBSYSTEM_VENDOR_ID, 4, &ierr);
//
//  printf( "\nPCI_SUBSYSTEM_VENDOR_ID: %x (%i), ierr=%i\n",ind,ind, ierr);

//塞  base_address
  printf( "PCI_BASE_ADDRESSes = ");
  for(i=0;i<6;i++)
  {   from->base_address[i] =
            tpci_ReadPCIdata(hfPCI, pciFindData.byPCIBusNumber,
                          pciFindData.byPCIFunctionNumber,
                          PCI_BASE_ADDRESS_0+i*4,  &ierr);
      printf( "(%i=%x, ierr=%i) ",i,from->base_address[i], ierr);
  }
/* 8 */
  from->irq = tpci_ReadPCIdata(hfPCI, pciFindData.byPCIBusNumber,
                          (pciFindData.byPCIFunctionNumber>>3),(pciFindData.byPCIFunctionNumber&0x7),
                          PCI_INTERRUPT_LINE, 1, &ierr);
  printf( "\nPCI_irq= %i=%x, ierr=%i\n",from->irq,from->irq, ierr);


  return  from;
}

int pci_read_config_dword(struct pci_dev *dev, u8 where, u32 *val)
{ int rc, ierr;

  rc = tpci_ReadPCIdata(hfPCI, dev->busNumber,
                        (dev->devfn>>3),(dev->devfn & 0x7),
                        where, 4, &ierr);
  if(ierr) *val = 0;
  else     *val = rc;
  return rc;
}

/*************************************************************************/
/*                                                                       */
/* from drv780.c                                                         */
/*                                                                       */
/*************************************************************************/

/* Read DSP program memory */
/*  ᫮  ணࠬ - 24  */
static int read_pm(BOARD_STRUCT *b, unsigned addr, PM_WORD *data, int n)
{
   unsigned base;
   int i, c;
   unsigned short int *pdata;
   if(b==NULL) return -1;
//xz    if(b->array == NULL) return -1;
   base = b->base;
   addr &= 0x3FFF;
   pdata = (unsigned short int *) data;

   enterIOPL32();
   _outpw(base + IDMA_ADDR,addr);
    for(i=0; i < n*2; i++)
         pdata[i] = _inpw(base + IDMA_DATA);
   leaveIOPL32();

   return n;
}


/* Write DSP program memory */
static int write_pm(BOARD_STRUCT *b, unsigned addr, PM_WORD *data, int n)
{
   int base;
   int i;
   unsigned short int *pdata;
static   unsigned short int tst[10000];

   if(b==NULL) return -1;
//xz    if(b->array == NULL) return -1;
   base = b->base;
   addr &= 0x3FFF;
   pdata = (unsigned short int *) data;

   enterIOPL32();
   _outpw(base + IDMA_ADDR,addr);
    for(i=0; i < n*2; i++)
         _outpw(base + IDMA_DATA, pdata[i]);

   _outpw(base + IDMA_ADDR,addr);
    for(i=0; i < n*2; i++)
        tst[i] = _inpw(base + IDMA_DATA);

   leaveIOPL32();
/* ࠢ */
   for(i=0;i<n*2;i++)
   {  if(tst[i] != pdata[i])
      {  printf("\abred\n");
         break;
      }

   }
 return n;

}

/* Read DSP data memory */
static int read_dm(BOARD_STRUCT *b, unsigned addr, DM_WORD *data, int n)
{  int base,i;
   unsigned short int *pdata;
   if(b==NULL) return -1;
//xz    if(b->array == NULL) return -1;
   base = b->base;
   addr = (addr & 0x3FFF) | ADDR_DM;  // ADDR_DM = 0x4000;

   pdata = (unsigned short int *) data;

   enterIOPL32();
   _outpw(base + IDMA_ADDR,addr);
    for(i=0; i < n; i++)
         pdata[i] = _inpw(base + IDMA_DATA);
   leaveIOPL32();

 return n;

}

/* Write DSP data memory */
static int write_dm(BOARD_STRUCT *b, unsigned addr, DM_WORD *data, int n)
{  int base,i;
   unsigned short int *pdata;
static   unsigned short int tst[10000];
   if(b==NULL) return -1;
//xz    if(b->array == NULL) return -1;
   base = b->base;
   addr = (addr & 0x3FFF) | ADDR_DM;

   pdata = (unsigned short int *) data;

   enterIOPL32();
   _outpw(base + IDMA_ADDR,addr);
    for(i=0; i < n; i++)
         _outpw(base + IDMA_DATA, pdata[i]);

   _outpw(base + IDMA_ADDR,addr);
    for(i=0; i < n; i++)
        tst[i] = _inpw(base + IDMA_DATA);

   leaveIOPL32();
/* ࠢ */
   for(i=0;i<n;i++)
   {  if(tst[i] != pdata[i])
      {  printf("\abred %i\n",__LINE__);
         break;
      }
   }

   return n;
}

/* Read 1 word from DSP program memory */
static long get_pm_word(BOARD_STRUCT *b, unsigned addr)
{
}
/* Write 1 word to DSP program memory */
static int put_pm_word(BOARD_STRUCT *b, unsigned addr, PM_WORD pw)
{
}

/* Read 1 word from DSP data memory */
static int get_dm_word(BOARD_STRUCT *b, unsigned addr)
{
   int base,rc;
   if(b==NULL) return -1;
   addr = (addr & 0x3FFF) | 0x4000;
   base = b->base;
   enterIOPL32();
   _outpw(base + IDMA_ADDR,addr);
   rc = _inpw(base + IDMA_DATA);
   leaveIOPL32();

 return rc;
}

/* Write 1 word to DSP data memory */
static int put_dm_word(BOARD_STRUCT *b, unsigned addr, DM_WORD w)
{
   int base;
   if(b==NULL) return -1;
   addr = (addr & 0x3FFF) | 0x4000;
   base = b->base;
   enterIOPL32();
   _outpw(base + IDMA_ADDR,addr);
   _outpw(base + IDMA_DATA, w);
   leaveIOPL32();
    return 0;
}

/* Enable EEPROM writing */
static int flash_enable_write(BOARD_STRUCT *b, int a)
{
}

/* Write EEPROM word */
static int flash_set_word(BOARD_STRUCT *b, unsigned addr, unsigned data)
{
}

/* Write EEPROM words */
static int flash_write(BOARD_STRUCT *b, unsigned addr, DM_WORD *fw, int n)
{
}

/* Read EEPROM word(s) */
int flash_read(BOARD_STRUCT *b, unsigned addr, DM_WORD *fw, int n)
{
 int cntrl;
 unsigned x, d, i;

   cntrl = b->ioplx + PLX_CNTRL;
   enterIOPL32();

   x = _inpd(cntrl);
   x = (x | L780_EECS) & ~L780_EESK & ~L780_EEWD;
   _outpd(cntrl,x);

 udelayIOPL32(flash_delay);


// printf("\nPort0=%x ", b->ioplx);
// printf("Port=%x \n", cntrl);

 d = 0x180 | (addr & 0x3F);  /* 110XXXXXX */
 for(i=0; i<9; i++)
 {
  if(d & 0x100) x |= L780_EEWD;
  else x &= ~L780_EEWD;
//  outl(x, cntrl);
   _outpd(cntrl,x);
  udelayIOPL32(flash_delay);
  x |= L780_EESK;
//  outl(x, cntrl);
   _outpd(cntrl,x);
  udelayIOPL32(flash_delay);
  x &= ~L780_EESK;
//  outl(x, cntrl);
   _outpd(cntrl,x);
  udelayIOPL32(flash_delay);
  d <<= 1;
 }
 udelayIOPL32(flash_delay);

 x = _inpd(cntrl);
 x &= ~L780_EEWD;
// outl(x, cntrl);
   _outpd(cntrl,x);
 udelayIOPL32(flash_delay);

 while(n>0)
 {
  d = 0;
  for(i=0; i<16; i++)
  {
   d <<= 1;
   x |= L780_EESK;
//   outl(x, cntrl);
   _outpd(cntrl,x);
   udelayIOPL32(flash_delay);
   x &= ~L780_EESK;
//   outl(x, cntrl);
   _outpd(cntrl,x);
   udelayIOPL32(flash_delay);
   x = _inpd(cntrl);
   udelayIOPL32(flash_delay);
   if(x & L780_EERD) d |= 1;
  }
  *(fw++) = d;
  n--;
 }

 x = _inpd(cntrl);
 x &= ~L780_EECS;
// outl(x, cntrl);
   _outpd(cntrl,x);
 udelayIOPL32(flash_delay);

 leaveIOPL32();

#if POKA
#endif  //POKA

 return d;
}

/* Reset PLX */
static int plx_reset(BOARD_STRUCT *b)
{  int x;

   if(b==NULL) return -1;
 enterIOPL32();
   x = _inpd(b->ioplx + PLX_CNTRL);
   x |= CNTRL_RESET;  /* !!! */
   _outpd(b->ioplx + PLX_CNTRL,x);
   udelayIOPL32(flash_delay);
   x &= ~CNTRL_RESET;
   _outpd(b->ioplx + PLX_CNTRL,x);
   udelayIOPL32(flash_delay);
 leaveIOPL32();
 return 0;
}

/* Enable/disable interrupt from PLX */
static int plx_int_enable(BOARD_STRUCT *b, int State)
{
   int x;
   if(b==NULL) return -1;
   x = ICS_LI1P | ICS_LI2P;
   if(State) x |= ICS_PIE | ICS_LI1E;

   enterIOPL32();
    _outpd(b->ioplx + PLX_INTCSR, x);
   leaveIOPL32();

   return 0;
}

/* Command */
static int plx_command(BOARD_STRUCT *b)
{
 if(b==NULL) return -1;
   enterIOPL32();
      _outpw(b->base + DSP_INTR,0);
   leaveIOPL32();
 return 0;

}

static int get_var(BOARD_STRUCT *b, unsigned n)
{
 return get_dm_word(b, n + b->var);
}

static int set_var(BOARD_STRUCT *b, unsigned n, DM_WORD value)
{
 return put_dm_word(b, n + b->var, value);
}

static int irq_reset(BOARD_STRUCT *b)
{
   enterIOPL32();
   _outpw(b->base + DSP_RESET,0);
   leaveIOPL32();
  return 0;
}

static int out_command(BOARD_STRUCT *b, int Command)
{ int i;
  set_var(b, L_COMMAND, Command);
  plx_command(b);
  for(i=0; i<0x1000; i++)
  {
    Command = get_var(b, L_COMMAND);
    if(Command==0)
               return 0;
    if(Command==-1)
               return -1;
  }
  return -1;

}

static int enable_int(BOARD_STRUCT *b, int State)
{
 set_var(b, L_ENABLE_IRQ_VALUE, State);
 out_command(b, C_ENABLE_IRQ);
 return 0;
}

static int enable_adc(BOARD_STRUCT *b, int State)
{
 set_var(b, L_ADC_ENABLE, State);
 out_command(b, C_ENABLE_ADC);
 return 0;
}

static int enable_dac(BOARD_STRUCT *b, int State)
{
 set_var(b, L_DAC_ENABLE, State);
 out_command(b, C_ENABLE_DAC);
 return 0;
}

static int get_sample(BOARD_STRUCT *b, int Channel)
{
 set_var(b, L_ADC_CHANNEL, Channel);
 set_var(b, L_ADC_SAMPLE, 0x8000);
 out_command(b, C_ADC_SAMPLE);
 return get_var(b, L_ADC_SAMPLE);
}

static int set_sample(BOARD_STRUCT *b, int Channel, int Value)
{
 set_var(b, L_DAC_VALUE, (Value & 0x8FFF) | (Channel << 12));
 out_command(b, C_TEST);
 return 0;
}

static int ttl_in(BOARD_STRUCT *b)
{
 out_command(b, C_TTL_IN);
 return get_var(b, L_TTL_IN);
}

static int ttl_out(BOARD_STRUCT *b, int Value)
{
 set_var(b, L_TTL_OUT, Value);
 return out_command(b, C_TTL_OUT);
}
/* EK */
int ttl_in(int dev)
{
   BOARD_STRUCT *b;
   int i,j,l,rc;
   i = dev;
   if(i <= 0 || i > Boards)
                   return -EINVAL;

   b = &LCardBoard[i-1];
   out_command(b, C_TTL_IN);
   return get_var(b, L_TTL_IN);
}

int ttl_out(int dev, int Value)
{
   BOARD_STRUCT *b;
   int i,j,l,rc;
   i = dev;
   if(i <= 0 || i > Boards)
                   return -EINVAL;

   b = &LCardBoard[i-1];
   set_var(b, L_TTL_OUT, Value);
   return out_command(b, C_TTL_OUT);
}

#define L_PFCSC 0xfe6
#define L_PFD   0xfe5

int pflagCSC_in(int dev)
{  BOARD_STRUCT *b;
   int i,rc;
   i = dev;
   if(i <= 0 || i > Boards) return -EINVAL;
   b = &LCardBoard[i-1];

   return get_var(b,L_SET_PFCSC);
}

int pflag_in(int dev)
{  BOARD_STRUCT *b;
   int i,rc;
   i = dev;
   if(i <= 0 || i > Boards) return -EINVAL;
   b = &LCardBoard[i-1];

   return get_var(b,L_SET_PFD);
}

int pflag_out(int dev, int Value)
{  BOARD_STRUCT *b;
   int i,rc;
   i = dev;
   if(i <= 0 || i > Boards) return -EINVAL;
   b = &LCardBoard[i-1];
   set_var(b, L_SET_PFD, Value);

   return out_command(b, C_SET_PF);
}
int pflagCSC_out(int dev, int Value)
{  BOARD_STRUCT *b;
   int i,rc;
   i = dev;
   if(i <= 0 || i > Boards) return -EINVAL;
   b = &LCardBoard[i-1];
   set_var(b, L_SET_PFCSC, Value);
   return out_command(b, C_SET_PF);
}

int getADC(int dev,int Channel)
{  BOARD_STRUCT *b;
   int i,rc;
   i = dev;
   if(i <= 0 || i > Boards) return -EINVAL;
   b = &LCardBoard[i-1];
   return get_sample(b, Channel);
}

/*************/
static int set_adc_timing(BOARD_STRUCT *b, int *ff, int *cf)
{
 int cd, fd;
 int f;

 f = b->descr.freq;
 if(b->id == 0x761)
 {
  f = 10000000;  /* AVR clock */
  if(*cf==0) *cf = b->adc_max;  /* 0 => max ADC rate */
  cd = f / *cf;
  if(cd<1) cd = 1;
  if(cd>0x10000) cd = 0x10000;
  *cf = f / cd;
  if(*ff==0) return -1;
  if(*ff==0) *ff = b->rate;
  fd = f / *ff;  /* Frame period */
  fd -= cd * (b->channels - 1);  /* Interframe delay in AVR clocks */
  if(fd<=0) return -1;
 }
 else
 {
  if(*cf==0) *cf = b->adc_max;  /* 0 => max ADC rate */
  cd = f / *cf;
  if(cd<1) cd = 1;
  if(cd>0x10000) cd = 0x10000;
  *cf = f / cd;
  if(ff==0) return -1;
  if(*ff==0) *ff = b->rate;
  fd = f / *ff;  /* Frame period */
  fd -= cd * (b->channels);  /* Interframe delay */
  fd /= cd;  /* Interframe delay is in channel delays */
  if(fd<0) return -1;
  *ff = f / (cd * (b->channels + fd));
  cd -= 1;
 }
 set_var(b, L_ADC_RATE, cd);
 set_var(b, L_ADC_INTERFRAME, fd);
 set_var(b, L_FIRST_SAMPLE, cd * 2);
 out_command(b, C_SET_ADC_FRAME);
 return 0;
}

static int set_dac_rate(BOARD_STRUCT *b, int l)
{
 l = b->descr.freq / l;
 set_var(b, L_DAC_RATE, l/2);
 out_command(b, C_SET_DAC_RATE);
 return b->descr.freq / l;
}

  /* Set DSP type */

int set_dsp_type(BOARD_STRUCT *b)
{  int l, i, Dsp_Type,rc;


   l = 0;
   i = 0;
   while(dsp_name[i])
   {
      if(strncmp(b->descr.dsp_type, dsp_name[i], 4) == 0)
      {  l = i;
         break;
      }
      i++;
   }
// if(debug)
    printf("DSP type: %s\n", dsp_name[l]);

 b->bios = 1;

   Dsp_Type = get_var(b, L_DSP_TYPE);

   if(Dsp_Type == l)
               return 1;
/* EK ??

 b->max_fifo_adc = d_max_adc[l];
 b->max_fifo_dac = d_max_dac[l];
*/

 rc = get_var(b, L_READY);

 set_var(b, L_READY, 0);
 set_var(b, L_DSP_TYPE, l);

 rc = out_command(b, C_SET_DSP_TYPE);
 if(!rc)
 {
    if(l != 0)
           b->var = 0x3000; // ࠧ ᫥   C_SET_DSP_TYPE
     set_var(b, L_DSP_TYPE, l);

     for(i=0; i<100; i++)
     { if(get_var(b, L_READY))
               break;
       DosSleep(10);
     }
     if(i>=100)
           return 1;
 }
/*
 set_var(b, L_ADC_FIFO_BASE_INDEX, d_adc_index[l]);
 out_command(b, C_ADC_FIFO_CFG);
*/
 rc = get_var(b, L_READY);
 b->bios = 1;
 return 0;
}

static int set_buf(fifo_buf *fb, int size, int fragsize)
{
 fb->size = fb->maxsize = 0;
 fb->head = fb->tail = fb->count = 0;
// fb->data = alloc_dmabuf(size, GFP_USER);
  fb->data = (unsigned char*) calloc(size, 1);
 if(fb->data == NULL) return -ENOMEM;
// memset(fb->data, 0, size);
 fb->size = fb->maxsize = size;
 if(fragsize) fb->fragsize = fragsize;
 return 0;
}

static int free_buf(fifo_buf *fb)
{
 fb->size = fb->maxsize = 0;
 fb->head = fb->tail = fb->count = 0;
 if(fb->data == NULL) return -1;
// free_dmabuf(fb->data, fb->size);
 free( fb->data);
 return 0;
}


/***************************************************************************
* ஢ઠ ࠢ쭮 㧪 LBIOS   ࠡᯮᮡ                                 *
****************************************************************************/
int L780_test(BOARD_STRUCT *b)
{  int i;
   if(get_var(b, L_TMODE1) != 0x5555)
                                      return -1;
   if(get_var(b, L_TMODE2) != 0xAAAA)
                                      return -1;
   set_var(b, L_TEST_LOAD, 0x77BB);
   DosSleep(50);
   for(i=40;i>0;i--)
   {
       if(get_var(b, L_READY) > 0) break;
       DosSleep(100);
   }
   if(i<=0)
               return -1;
   if(!get_var(b, L_READY))
                   return -1;
   out_command(b, C_TEST);
   i = get_var(b, L_TEST_LOAD);
   DosSleep(50);
   if(i!=0xAA55)
           return -1;
//쪠   set_dsp_type(b);
//   set_dsp_type(b);
   b->bios = 1;
 return 0;

#if POKA
       if(((unsigned)GET_DM_WORD_PLX(bi, L_TMODE1_PLX) != 0x5555) ||
                                                       ((unsigned)GET_DM_WORD_PLX(bi, L_TMODE2_PLX) != 0xAAAA))
               return 0;
       else
       {
               int l=150;

               PUT_DM_WORD_PLX(bi, L_TEST_LOAD_PLX, 0x77bb);
               delay(50);
               while(!GET_DM_WORD_PLX(bi, L_READY_PLX) && l--)
                       delay(100);
               if(l == -1)
                       return 0;
               SEND_COMMAND_PLX(bi, C_TEST_PLX);
               delay(10);
               if((unsigned)GET_DM_WORD_PLX(bi, L_TEST_LOAD_PLX) != 0xAA55)
                       return 0;
       }
       return 1;
#endif
}


/* --- */
/* Interrupt task - called by interrupt handler */
//static void inttask(void *param)
//{
//}

/* Interrupt handler */
//static void keyhand(int irq, void *dev_id, struct pt_regs *regs)
//{
//}

/* Open device */
//static int device_open(struct inode *inode, struct file *file)
//{
//}

/* Close device */
//static int device_release(struct inode *inode, struct file *file)
//{
//}

/* Read from device */
//static ssize_t device_read(struct file *file, char *buffer, size_t length, loff_t *offset)
//{
//}

/* Write to device */
//static ssize_t device_write(struct file *file, const char *buffer, size_t length, loff_t *offset)
//{
// return -EINVAL;  /* Writing is not supported */
//}

/* Map */
//static int device_mmap(struct file *file, struct vm_area_struct *vma)
//{
//}

/* Poll */
//static unsigned device_poll(struct file *file, struct poll_table_struct *wait)
//{
//}


static int put_user(int val, int *ptr)
{  *ptr = val;
}

static int get_user(int &l, int *ptr)
{  l = *ptr;
}
static int  copy_to_user(void *to,void *from, int l)
{   memcpy(to,from,l);
    return 0;
}

static int copy_from_user(void *to, void *from, int l)
{
   memcpy(to,from,l);
    return 0;
}

/* Device I/O control */
//static int device_ioctl(struct inode *inode, struct file *file, unsigned ioctl_num,
// unsigned long param)
int l2_device_ioctl(int dev, unsigned ioctl_num, unsigned param)
{
   BOARD_STRUCT *b;
   copr_debug_buf cdbuf;
   int i,j,l,rc;
   channel_info chinf;
   sample_info sinf;
   fifo_buf *fb;
   frame_timing ft;
   sync_mode sm;

   i = dev;
   if(i <= 0 || i > Boards)
                   return -EINVAL;

   b = &LCardBoard[i-1];

 switch(ioctl_num)
 {
  case XDSP_ID:
      put_user(b->id, (int*) param);
  break;

  case SNDCTL_COPR_RESET:  /* Reset board */
    b->bios = 0;
    plx_int_enable(b, 0);
    plx_reset(b);
    b->var = 0x2000;
//    b->var = 0x3000;
  break;

  case XDSP_GET_INFO:  /* Get board description from flash */
     if(copy_to_user((void*) param, &b->descr, sizeof(BOARD_DESCR)))
                                                           return -EFAULT;
  break;

  case SNDCTL_COPR_LOAD:
     if(copy_from_user(&cbuf, (void*) param, sizeof(copr_buffer)))
                                                       return -EFAULT;
     plx_int_enable(b, 0);
     switch(cbuf.command)
     {
      case 0:  /* Read PM */
          read_pm(b, cbuf.offs, (PM_WORD*) cbuf.data, cbuf.len / sizeof(PM_WORD));
          return copy_to_user((void*) param, &cbuf, sizeof(copr_buffer));
      break;

      case 1:  /* Write PM */
          write_pm(b, cbuf.offs, (PM_WORD*) cbuf.data, cbuf.len / sizeof(PM_WORD));
      break;

      case 2:  /* Read DM */
          read_dm(b, cbuf.offs, (DM_WORD*) cbuf.data, cbuf.len / sizeof(DM_WORD));
          return copy_to_user((void*) param, &cbuf, sizeof(copr_buffer));
      break;

      case 3:  /* Write DM */
          write_dm(b, cbuf.offs, (DM_WORD*) cbuf.data, cbuf.len / sizeof(DM_WORD));
      break;

      case 0x40:  /* Read flash */
          flash_read(b, cbuf.offs, (DM_WORD*) cbuf.data, cbuf.len / sizeof(DM_WORD));
          return copy_to_user((void*) param, &cbuf, sizeof(copr_buffer));
      break;

      case 0x41:  /* Write flash */
          flash_enable_write(b, 1);
          l = flash_write(b, cbuf.offs, (DM_WORD*) cbuf.data, cbuf.len / sizeof(DM_WORD));
          flash_enable_write(b, 0);
          return l;
     }
//??  뢠
     plx_int_enable(b, 1);

   break;
/*************************************************************/
/* Get/set LBIOS variables */

  case SNDCTL_COPR_RDATA:
     if(copy_from_user(&cdbuf, (void*) param, sizeof(copr_debug_buf))) return -EFAULT;
     plx_int_enable(b, 0);
     cdbuf.parm2 = get_var(b, cdbuf.parm1);
     plx_int_enable(b, 1);
     if(copy_to_user((void*) param, &cdbuf, sizeof(copr_debug_buf))) return -EFAULT;
  break;

  case SNDCTL_COPR_WDATA:
     if(copy_from_user(&cdbuf, (void*) param, sizeof(copr_debug_buf))) return -EFAULT;
     plx_int_enable(b, 0);
     set_var(b, cdbuf.parm1, cdbuf.parm2);
     plx_int_enable(b, 1);
     if(copy_to_user((void*) param, &cdbuf, sizeof(copr_debug_buf))) return -EFAULT;
  break;

  case XDSP_SETIBUF:  /* Set input buffer size */
     get_user(l, (int*) param);
     free_buf(&b->InBuf);
     if(set_buf(&b->InBuf, l, 0)) return -ENOMEM;
  break;

  case XDSP_SETOBUF:  /* Set output buffer size */
     get_user(l, (int*) param);
     free_buf(&b->OutBuf);
     if(set_buf(&b->OutBuf, l, 0)) return -ENOMEM;
  break;

  case XDSP_COMMAND:
     get_user(l, (int*) param);
     if(out_command(b, l)) return -1;
  break;

  case XDSP_TEST:
     get_user(l, (int*) param);
     switch(l)
     {
      case 0:  /* Test BIOS */
          rc = L780_test(b);
          if(rc)
              return rc;
      break;

      case 0x80:
          l = b->bios;
      break;

      default: return -EINVAL;
     }
     put_user(l, (int*) param);
  break;

  case XDSP_SAMPLE_IN:
     if(copy_from_user(&sinf, (void*) param, sizeof(sample_info))) return -EFAULT;
     sinf.value = get_sample(b, sinf.channel);
     if(copy_to_user((void*) param, &sinf, sizeof(sample_info))) return -EFAULT;
  break;

  case XDSP_SAMPLE_OUT:
     if(copy_from_user(&sinf, (void*) param, sizeof(sample_info))) return -EFAULT;
     set_sample(b, sinf.channel, sinf.value);
  break;

  case XDSP_TTL_IN:
     l = ttl_in(b);
     put_user(l, (int*) param);
  break;

  case XDSP_TTL_OUT:
     get_user(l, (int*) param);
  return ttl_out(b, l);

  case XDSP_SET_TIMING:
     if(copy_from_user(&ft, (void*) param, sizeof(frame_timing))) return -EFAULT;
     set_adc_timing(b, &ft.frame_rate, &ft.channel_rate);
     b->rate = ft.frame_rate;
  break;

  case XDSP_SYNC_MODE:
     if(copy_from_user(&sm, (void*) param, sizeof(sync_mode))) return -EFAULT;
     if(sm.sync_type != SYNC_TYPE_NONE)
     {
         plx_int_enable(b, 0);
         enable_adc(b, 1);
     }
     i = j = -1;
     if(sm.sync_type & SYNC_TYPE_DIGITAL)
     {
          if(sm.sync_type & SYNC_TYPE_FRAME) i = 0;  /* Digital frame sync */
          else i = 1;  /* Digital start sync */
     }
       else
           if(sm.sync_type & SYNC_TYPE_ANALOG) i = 2;  /* Analog start sync */
     set_var(b, L_SYNC_TYPE, i);
     set_var(b, L_SYNC_CHANNEL, sm.sync_channel);
     set_var(b, L_SYNC_LEVEL, sm.sync_level);
     switch(sm.sync_type & SYNC_TYPE_MODE)
     {
          case SYNC_MODE_HIGH: i = 0; j = 0; break;
          case SYNC_MODE_LOW: i = 0; j = 1; break;
          case SYNC_MODE_RISE: i = 1; j = 0; break;
          case SYNC_MODE_FALL: i = 1; j = 1; break;
     }
     set_var(b, L_SYNC_EDGE, i);
     set_var(b, L_SYNC_MODE, j);
     out_command(b, C_SYNC_CONFIG);
     if(sm.sync_type != SYNC_TYPE_NONE)
     {
          b->trigger |= PCM_ENABLE_INPUT;
          plx_int_enable(b, 1);
     }
  break;

#if POKA
  case SNDCTL_DSP_GETCAPS:
     return put_user(caps, (int*) param);

  case SNDCTL_DSP_RESET:  /* Soft reset - don't kill LBIOS */
     plx_int_enable(b, 0);
     enable_int(b, 0);
     enable_dac(b, 0);
     enable_adc(b, 0);
     b->trigger = 0;
     fb = &b->InBuf;
     fb->head = fb->tail = fb->count = 0;
     fb = &b->OutBuf;
     fb->head = fb->tail = fb->count = 0;
     b->FifoIn = 0;
     b->FifoOut = 0;
     plx_int_enable(b, 1);
  break;

  case SNDCTL_DSP_STEREO:  /* Only 1 or 2 channels */
     get_user(l, (int*) param);
     if(file->f_mode & FMODE_READ)
     {
          if(l) l = 2;
          else l = 1;
          set_var(b, L_CONTROL_HEIGHT, l);
          out_command(b, C_LOAD_CONTROL_TABLE);
          b->channels = l;
     }
     if(file->f_mode & FMODE_WRITE)
     {
      if(l>2) l = 2;
     }
  break;
#endif //POKA

  case XDSP_SET_CHANNEL:
     if(copy_from_user(&chinf, (void*) param, sizeof(channel_info))) return -EFAULT;
     i = chinf.number;
     if(i>=128) return -EINVAL;
     plx_int_enable(b, 0);
     set_var(b, L_CONTROL_TABLE + i, chinf.log_channel);
     plx_int_enable(b, 1);
  break;

#if POKA
  case SNDCTL_DSP_CHANNELS:  /* This can enable more channels */
     get_user(l, (int*) param);
     if(l != 0)
     {
          plx_int_enable(b, 0);
          if(file->f_mode & FMODE_READ)
          {
               enable_adc(b, 0);
               b->channels = l;
               if(l>32) l = 32;
               set_var(b, L_CONTROL_HEIGHT, l);
               out_command(b, C_LOAD_CONTROL_TABLE);
               b->channels = l;
               i = b->max_fifo_adc / 4;
               i -= i % l;  /* Fragment size in DM_WORDs */
               b->InBuf.fragsize = i * sizeof(DM_WORD);
               set_var(b, L_IRQ_STEP, i);
               j = b->max_fifo_adc;
               j -= j % l;  /* DSP buffer size in DM_WORDs */
               set_var(b, L_ADC_NEW_FIFO_LENGTH, j);
               b->InBuf.size = j * sizeof(DM_WORD);
               out_command(b, C_ADC_FIFO_CFG);
               enable_adc(b, 1);
          }
          if(file->f_mode & FMODE_WRITE)
          {
               enable_dac(b, 1);
               if(l>2) l = 2;
          }
          plx_int_enable(b, 1);
     }
       else l = b->channels;
     return put_user(l, (int*) param);

  case SOUND_PCM_READ_CHANNELS:
     l = b->channels;
     return put_user(l, (int*) param);

  case SNDCTL_DSP_SPEED:  /* Set frame rate */
     get_user(l, (int*) param);
     plx_int_enable(b, 0);
     if(file->f_mode & FMODE_READ)
     {
          enable_adc(b, 0);
          i = get_var(b, L_CONTROL_HEIGHT);
          if(l!=0)
          {
               b->rate = l;
               l1 = 0;
               set_adc_timing(b, &l, &l1);
               b->rate = l;
          }
          else l = b->rate;
          enable_adc(b, 1);
     }
     if(file->f_mode & FMODE_WRITE)
     {
          enable_dac(b, 0);
          if(l!=0)
          {
               l1 = l * 2;
               l1 = set_dac_rate(b, l1);
               l = l1 / 2;
          }
            else l = b->rate;
          enable_dac(b, 1);
     }
     set_var(b, L_IRQ_STEP, b->InBuf.fragsize);
     enable_int(b, 1);
     plx_int_enable(b, 1);
     b->rate = l;
     put_user(l, (int*) param);
  break;

  case SOUND_PCM_READ_RATE:
     put_user(b->rate, (int*) param);
  break;

  case SNDCTL_DSP_GETFMTS:
     return put_user(fmts, (int*) param);

  case SNDCTL_DSP_SETFMT:
     get_user(i, (int*) param);
     i = AFMT_S16_LE;
     put_user(i, (int*) param);
  break;

  case SOUND_PCM_READ_BITS:
     return put_user(b->adc_bits, (int*) param);

#endif //POKA

  case SNDCTL_DSP_GETBLKSIZE:
     return put_user(b->InBuf.fragsize, (int*) param);

/* OSS parameters: MMMMSSSS */
/* XDSP parameters: If MMMM=0, SSSS - fragment size in bytes */

#if POKA
  case SNDCTL_DSP_SETFRAGMENT:
     get_user(l, (int*) param);
     j = l & 0xFFFF;
     i = l >> 16;
     if(i!=0) j = 1 << j;  /* OSS call */
     if(file->f_mode & FMODE_READ)
     {
          if(j >= b->InBuf.size) return -EINVAL;
          b->InBuf.fragsize = j;
          set_var(b, L_IRQ_STEP, l / sizeof(DM_WORD));
     }
     if(file->f_mode & FMODE_WRITE)
     {
          if(j >= b->OutBuf.size) return -EINVAL;
          b->OutBuf.fragsize = j;
     }
  break;
#endif //POKA

  case SNDCTL_DSP_GETTRIGGER:
     return put_user(b->trigger, (int*) param);

#if POKA
  case SNDCTL_DSP_SETTRIGGER:
     get_user(l, (int*) param);
     plx_int_enable(b, 0);
     b->trigger = l;
     if(file->f_mode & FMODE_READ)
     {
          if(l & PCM_ENABLE_INPUT) enable_adc(b, 1);
          else enable_adc(b, 0);
     }
     if(file->f_mode & FMODE_WRITE)
     {
          if(l & PCM_ENABLE_OUTPUT) enable_dac(b, 1);
          else enable_dac(b, 0);
     }
     plx_int_enable(b, 1);
  break;

  case SNDCTL_DSP_GETOSPACE:
     if(!(file->f_mode & FMODE_READ)) return -EINVAL;
     fb = &b->OutBuf;
     abinfo.bytes = fb->size - fb->count;
     abinfo.fragstotal = fb->size / fb->fragsize;
     abinfo.fragments = fb->count / fb->fragsize;
     abinfo.fragsize = fb->fragsize;
     if(copy_to_user((void*) param, &abinfo, sizeof(audio_buf_info)))
                                                               return -EFAULT;
  break;

  case SNDCTL_DSP_GETISPACE:
     if(!(file->f_mode & FMODE_READ)) return -EINVAL;
     fb = &b->InBuf;
     abinfo.bytes = fb->count;
     abinfo.fragstotal = fb->size / fb->fragsize;
     abinfo.fragments = fb->count / fb->fragsize;
     abinfo.fragsize = fb->fragsize;
     if(copy_to_user((void*) param, &abinfo, sizeof(audio_buf_info))) return -EFAULT;
  break;

  case SNDCTL_DSP_GETIPTR:
     if(!(file->f_mode & FMODE_READ)) return -EINVAL;
     cinfo.bytes = b->InBuf.count;
     cinfo.blocks = b->InBuf.count / b->InBuf.fragsize;
     cinfo.ptr = b->InBuf.tail;
     b->InBuf.count = 0;
     b->InBuf.head = b->InBuf.tail;
     if(copy_to_user((void*) param, &cinfo, sizeof(count_info))) return -EFAULT;
  break;

  case SNDCTL_DSP_MAPINBUF:
     if(copy_from_user(&bmdesc, (void*) param, sizeof(bmdesc))) return -EFAULT;
     if(bmdesc.size > b->InBuf.size) return -EINVAL;
     if(bmdesc.buffer==NULL)
     {
           bmdesc.buffer = (void*) get_unmapped_area((int) bmdesc.buffer, bmdesc.size);
     }
     if(remap_page_range((int) bmdesc.buffer,
                         virt_to_phys(b->InBuf.data),
                         bmdesc.size,
                         PAGE_READONLY))
                               return -EAGAIN;
     b->InBuf.count = 0;
     if(copy_to_user((void*) param, &bmdesc, sizeof(bmdesc))) return -EFAULT;
  break;

  case SNDCTL_DSP_MAPOUTBUF:
     if(copy_from_user(&bmdesc, (void*) param, sizeof(bmdesc))) return -EFAULT;
     if(bmdesc.size > b->OutBuf.size) return -EINVAL;
     if(bmdesc.buffer==NULL)
     {
          bmdesc.buffer = (void*) get_unmapped_area((int) bmdesc.buffer, bmdesc.size);
     }
     if(remap_page_range((int) bmdesc.buffer,
      virt_to_phys(b->OutBuf.data),
      bmdesc.size,
      PAGE_SHARED)) return -EAGAIN;
     b->OutBuf.count = 0;
     if(copy_to_user((void*) param, &bmdesc, sizeof(bmdesc))) return -EFAULT;
  break;

  case SOUND_MIXER_READ_DEVMASK:
  case SOUND_MIXER_READ_STEREODEVS:
     put_user(mixer_devmask, (int*) param);
  break;

  case SOUND_MIXER_READ_RECMASK:
  case SOUND_MIXER_READ_RECSRC:
     put_user(mixer_recmask, (int*) param);
  break;

  case SOUND_MIXER_READ_LINE:
  case SOUND_MIXER_WRITE_LINE:
  case SOUND_MIXER_WRITE_PCM:
  case SOUND_MIXER_READ_PCM:
     put_user(mixer_vol, (int*) param);
  break;

#endif //POKA

/*************************************************************/
  default:
      printf("\nL780: unknown ioctl(%08X)\n", ioctl_num);
  return -EINVAL;
 }
 return 0;

}

int l2_device_ioctl(int dev, unsigned ioctl_num)
{
   return l2_device_ioctl(dev,ioctl_num,0);

}

int init_module(void)
{
  struct pci_dev *dev, dev0;
  BOARD_STRUCT *b, *b1;
  int x, m, t, bn, unit;
  int rc, devIndex;
  long addr[6];

   StartHiresTimer();

  b1 = b = NULL;

//  dev=pci_find_device(VendorId, DeviceId, &dev0);
//  rc =  pci_read_config_dword(dev, PCI_SUBSYSTEM_VENDOR_ID, (u32 *) &x);
  for(devIndex=0; devIndex<1; devIndex++)
  {
      dev0.index = devIndex;
      dev = pci_find_device(VendorId, DeviceId, &dev0);
      if(dev == NULL)
          break;
       rc = pci_read_config_dword(dev, PCI_SUBSYSTEM_VENDOR_ID, (u32 *) &x);
      t = 0;
      while(1)
      {  m = sub_id[t];
         if(m == 0) break;
         if(m == x) break;
         t++;
      }
      if(m == 0) continue;  /* Unknown PLX device */
      printf("  %s\n",PLX_Board_Names[t]);

     if((dev->base_address[1] & PCI_BASE_ADDRESS_SPACE)
                          != PCI_BASE_ADDRESS_SPACE_IO) continue;
     if((dev->base_address[2] & PCI_BASE_ADDRESS_SPACE)
                          != PCI_BASE_ADDRESS_SPACE_IO) continue;
     if((dev->base_address[3] & PCI_BASE_ADDRESS_SPACE)
                          != PCI_BASE_ADDRESS_SPACE_MEMORY) continue;
     addr[1] = dev->base_address[1] & PCI_BASE_ADDRESS_IO_MASK;
     addr[2] = dev->base_address[2] & PCI_BASE_ADDRESS_IO_MASK;
     addr[3] = dev->base_address[3] & PCI_BASE_ADDRESS_MEM_MASK;

//   ⠪
//   if(check_region(addr[1], PLX_LCR_EXTENT)) continue;
//  if(check_region(addr[2], IDMA_EXTENT)) continue;
     bn = Boards;
//     b = (BOARD_STRUCT *) calloc(sizeof(BOARD_STRUCT), 1);    // GFP_KERNEL??
//     if(b == NULL) return -ENOMEM;
     b = &LCardBoard[Boards];
     b->number = bn;
     b->next = NULL;
     b->dev = dev;
     b->id = t_id[t];
     b->adc_bits = t_adc_bits[t];
     b->adc_max = t_adc_max[t];

     if(b1==NULL) FirstBoard = b;
     else b1->next = b;
     Boards++;

     b->ioplx = addr[1] & PCI_BASE_ADDRESS_IO_MASK;
     b->base  = addr[2] & PCI_BASE_ADDRESS_IO_MASK;
//     request_region(b->ioplx, PLX_LCR_EXTENT, DeviceName);
//     request_region(b->base, IDMA_EXTENT, DeviceName);
//     b->array = ioremap(addr[3] + 0x1000, 0x1000);

// ࣠樨 10ᥪ প ᯮ㥬 inp    1 
    if(Boards == 1)
            init_usTimerDelay(b->ioplx );

     m = sizeof(BOARD_DESCR) / sizeof(DM_WORD);
     flash_read(b, 0, (DM_WORD*) &b->descr, m);
/*******************************************/
     b->bios = 0;     /* Bios not loaded */
     b->var = 0x2000; /* Data area offset in DSP DM */
//     b->format = AFMT_S16_LE; - 䨪
     b->rate = 1000;
     plx_int_enable(b, 0);

//  request_irq(dev->irq, keyhand, SA_SHIRQ, DeviceName, (void*) b);
//  b1 = b;
//  if(major>0)
//  {
//   b->unit = bn;
//  }
//  else  /* Register as sound driver */
//  {
//   unit = register_sound_dsp(&fops, slot);
//   if(slot >= 0) slot++;
//   if(unit < 0) return unit;
//   b->unit = unit;
//  }
//  printk("l780: unit %d\n", b->unit);

      PCIdev0 = dev0;

    }


  return Boards;

}
