/* xdsp.h */
/* XDSP interface */

#ifndef __XDSP_H
#define __XDSP_H

//#include <linux/ioctl.h>
//#include <linux/soundcard.h>
//#include <asm/types.h>

#include "l7_port.h"
#include "linux_ioctl.h"

//typedef __u16 DM_WORD;
typedef short int  DM_WORD;
//typedef __s32 PM_WORD;
typedef long int  PM_WORD;

#define ADDR_DM 0x4000

typedef struct _channel_tab
{
 int n;
 int ch[255];
} channel_tab;

typedef struct _channel_info
{
 int number;
 int log_channel;
 int flags;
 int amp;
} channel_info;

typedef struct _sample_info
{
 int channel;
 int value;
} sample_info;

typedef struct _mem_info
{
 int address;
 int size;
 void *buffer;
} mem_info;

typedef struct _frame_timing
{
 int frame_rate;
 int channel_rate;
} frame_timing;

/* Sync types */

#define SYNC_TYPE_NONE 0
#define SYNC_TYPE_DIGITAL 0x10
#define SYNC_TYPE_ANALOG 0x20
#define SYNC_TYPE_FRAME 0x80

#define SYNC_TYPE_MODE 0x0F

/* Sync modes */

#define SYNC_MODE_HIGH 0  /* High level */
#define SYNC_MODE_LOW  1  /* Low level */
#define SYNC_MODE_RISE 2  /* Rising edge */
#define SYNC_MODE_FALL 3  /* Falling edge */

typedef struct _sync_mode
{
 int sync_type;
 int sync_channel;
 int sync_level;
} sync_mode;

#define XDSP_RESET _IO('L', 0x10)
#define XDSP_ID _IOR('L', 0x08, int)
#define XDSP_GET_INFO _IOR('L', 0x21, char[128])
#define XDSP_SETIBUF _IOW('L', 0x30, int)
#define XDSP_SETOBUF _IOW('L', 0x31, int)

#define XDSP_SET_CHANNEL _IOW('L', 0x33, channel_info)
#define XDSP_CHANNEL_TAB _IOW('L', 0x34, channel_tab)

#define XDSP_SET_TIMING _IOWR('L', 0x35, frame_timing)
#define XDSP_SYNC_MODE _IOW('L', 0x36, sync_mode)
#define XDSP_GET_DATA _IOW('L', 0x38, int)
#define XDSP_PUT_DATA _IOR('L', 0x38, int)
#define XDSP_COMMAND _IOW('L', 0x39, int)
#define XDSP_TEST _IOWR('L', 0x40, int)
#define XDSP_SAMPLE_IN _IOR('L', 0x48, sample_info)
#define XDSP_SAMPLE_OUT _IOW('L', 0x48, sample_info)
#define XDSP_TTL_IN _IOR('L', 0x50, int)
#define XDSP_TTL_OUT _IOW('L', 0x50, int)

#endif
