#ifndef __XDSPLIB_H
#define __XDSPLIB_H

#include <fcntl.h>
//#include <sys/soundcard.h>
//#include <xdsp/xdsp.h>
#include "l7_port.h"
#include "xdsp.h"

/* Open modes */

#define XDSP_ADC O_RDONLY
#define XDSP_DAC O_WRONLY
#define XDSP_DUPLEX O_RDWR
#define XDSP_NONBLOCK O_NONBLOCK

int xdspOpen(char*, int);
int xdspClose(int);
int xdspRead(int, void*, int);
int xdspWrite(int, void*, int);
int xdspGetInfo(int, void*);
int xdspReadPM(int, int, int, PM_WORD*);
int xdspWritePM(int, int, int, PM_WORD*);
int xdspReadDM(int, int, int, DM_WORD*);
int xdspWriteDM(int, int, int, DM_WORD*);
int xdspBiosTest(int);
int xdspGetInPtr(int);
int xdspGetOutPtr(int);
int xdspEnableInput(int, int);
int xdspEnableOutput(int, int);
int xdspSetChannels(int, int);
int xdspSetChannelTab(int, int, int*);
int xdspSetSpeed(int, int*);
int xdspSetTiming(int, frame_timing*);
int xdspSetSync(int, sync_mode*);
void *xdspMapBuf(int, int, long, long);
int xdspUnMapBuf(int, void*, long);
int xdspStart(int dev, int x);
int xdspLoad(int dev, int cmd, void *buf, int nwords, int wsize, int addr);
int xdspGetData(int dev);
int xdspPutData(int dev, int x);
int xdspReset(int dev);
int xdspGetId(int dev);
int xdspTest(int dev, int c);

#endif
